/*
 * excpt.h
 *
 * Define the exception handling macros for _try/_except()/_finally.
 *
 * This header file is meant for use with MSVCRT.DLL as included with
 * Windows 95(tm) and Windows NT(tm). In conjunction with other versions
 * of the standard C library things may or may not work so well.
 *
 * Contributors:
 *  Created by Mikey (jeffdb@netzone.com)
 *	Modified by K. Haley (khaley@bigfoot.com)
 *
 *  THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain. You may
 *  use, modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but
 *  WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 *  DISCLAMED. This includes but is not limited to warranties of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/* ----------------------------------------------------------------------------
	these structures are used by VC++ exception handling
	and except_handler3. untill gcc supports _try/_except/_finally
	directly the necessary #defs' are below,
	you must  write your own system
	level exception handling routine to use this ;^). (DONE)

// write your own exception handlers for SetUnhandledExceptionFilter
//    using this prototype
int __cdecl except_handler(
struct _EXCEPTION_RECORD *ExceptionRecord,
void * EstablisherFrame,
struct _CONTEXT *ContextRecord,
void * DispatcherContext
);

typedef struct _SCOPETABLE
{
unsigned long previousTryLevel;
int __stdcall (*lpfnFilter)(); 		// address of filter function for this _try/_except 0 for finally
void __stdcall (*lpfnHandler)(); 	// address of _except _except_handler3 returns here
		     													// if EXCEPTION_EXECUTE_HANDLER in filter function
} SCOPETABLE;

typedef struct _EXCEPTION_REGISTRATION
{
FARPROC *prev; // pointer to previous EXCEPTION_REGISTRATION
FARPROC handler; // address of current _except_handler function
} EXCEPTION_REGISTRATION; //basic OS provided exception handling
				//must be built on stack
				//and registered at %fs:0

This header file is a kludge to add _try/_except _try/finally frame based 
exception handling to gcc, at the begining are some of the 
structures/functions that would be used, if this were written in c, 
however in order to implement this
I had to use a bastard combination of c, inline functions, assembly and extended
assembly and conditional assembly.

WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING

You must compile with -fno-omit-frame-pointer -O0 for this to work
the ld options --heap and --stack seam to cause problems. (and are not needed)

also the variables 
__xcpt_happened	__xcpt_filter_result __xcpt[ 1-7 ]

are instantiated here, for each function that uses _try/_except _try/_finally

use the macro _SXV( )
in EACH FUNCTION that contains a _try block immediatly before local variables
are declared, like this

int main()
{
_SXV()
int your, variables;
DWORD This_is_a_var = 99;
}

You will need to use the macro _END_FINALLY before the
end of any _finally blocks

_finally
{
free(MYSTUFF);
_END_FINALLY
}

RpcEndFinally is predefined, you don't need to use _END_FINALLY with it.

*/
//#ifndef __STRICT_ANSI__

#ifndef RC_INVOKED

#ifndef _EXCPT_H_
#define _EXCPT_H_
#define _EXCPT_H

#pragma pack(push,8)

#ifndef _CRTIMP
#if defined(_DLL)
#define _CRTIMP __declspec(dllimport)
#else
#define _CRTIMP
#endif
#endif

typedef struct _SCOPETABLE
{
unsigned long previousTryLevel;
int __stdcall (*lpfnFilter)(); 		// address of filter function for this _try/_except 0 for finally
void __stdcall (*lpfnHandler)(); 	// address of _except _except_handler3 returns here
		     													// if EXCEPTION_EXECUTE_HANDLER in filter function
} SCOPETABLE;

typedef struct _VC_EXCEPTION_REGISTRATION {
unsigned long stan_stack;
unsigned long xcept_ptrs;
unsigned long prev;
unsigned long handler;
SCOPETABLE *tbl_ptr;
unsigned long trylevel;
unsigned long _ebp;
} VC_EXCEPTION_REGISTRATION;

struct _EXCEPTION_RECORD;
struct _CONTEXT;

#ifdef __cplusplus
extern "C" {
#endif

#define EH_NONCONTINUABLE	0x01
#define EH_UNWINDING		0x02
#define EH_EXIT_UNWIND		0x04
#define EH_STACK_INVALID	0x08
#define EH_NESTED_CALL		0x10

#define EXCEPTION_EXECUTE_HANDLER	1
//#define EXCEPTION_CONTINUE_EXECUTION   -1
#define EXCEPTION_CONTINUE_SEARCH       0

typedef enum {
    ExceptionContinueExecution,
    ExceptionContinueSearch,
    ExceptionNestedException,
    ExceptionCollidedUnwind
} EXCEPTION_DISPOSITION;

/*extern _CRTIMP __cdecl EXCEPTION_DISPOSITION _except_handler3(
struct _EXCEPTION_RECORD *ExceptionRecord, void * EstablisherFrame,
struct _CONTEXT *ContextRecord, void * DispatcherContext );
*/
//_CRTIMP __cdecl int _abnormal_termination(void);

//#define AbnormalTermination         _abnormal_termination
//#define abnormal_termination        _abnormal_termination

// vc++ generated functions

#define GetExceptionInformation() \
__vcer.xcept_ptrs

#define GetExceptionCode()\
(**((int**)__vcer.xcept_ptrs))

#define RpcExceptionCode() GetExceptionCode()

//the above macros are only usable inside _try/_except block
//gcc will not generate a warning if these are used
//outside the _except block, but you will get garbage results

//the exception handler
int mexcept_handler3(
	struct _EXCEPTION_RECORD*	pExceptionRecord,
	VC_EXCEPTION_REGISTRATION*	pRegistrationFrame,
	struct _CONTEXT*		pContextRecord,
	void*
	);

#define _SXV(args...) \
__asm__ __volatile__("/BEGIN_SXV\n");\
VC_EXCEPTION_REGISTRATION __vcer;\
int __volatile__ __xcpt_filter_result __attribute__((__unused__));\
int __volatile__ __xcpt_happened __attribute__((__unused__)); ## args ;\
__asm__ __volatile__(".equ __except_list, 0\n");\
__vcer.trylevel=-1;\
__vcer.handler=(unsigned long)&mexcept_handler3;\
__asm__ __volatile__("/END_SXV\n");

#undef _try
#define _try \
__asm__ __volatile__(\
"\n/ BEGIN_TRY\n\t"\
"movl %%esp, %0;\n\t"\
"movl %%ebp, %1;\n"\
: "=g" (__vcer.stan_stack), "=g" (__vcer._ebp):);\
__asm__ __volatile__(\
	"movl %%fs:__except_list,%0\n\t"\
	"movl %2,%%fs:__except_list\n\t"\
"/ ScopeTable Pointer\n\t"\
	"movl $5f,%1\n"\
: "=g" (__vcer.prev), "=m" (__vcer.tbl_ptr): "r" (&__vcer.prev) : "memory");\
	++__vcer.trylevel;\
__asm__ __volatile__(\
"/ END_TRY");\
 	if(1)

#undef _except(args...)
#define _except(args...) \
/* BEGIN_EXCEPT */\
__asm__ __volatile__("/BEGIN_EXCEPT\n");\
__xcpt_happened = 0;\
__asm__ __volatile__(\
".section .rdata\n"\
".align 16, 0x0\n\t"\
	"5:.int -1, 1f, 2f\n"\
".text\n\t"\
	"jmp 2f\n"\
	"1:\n");\
__xcpt_filter_result = (## args);\
__asm__ __volatile__(\
        "cmpl $-1,%1\n\t"\
        "je 4f\n\t"\
        "incl %0\n\t"\
	: "=m" (__xcpt_happened)\
	: "a" (__xcpt_filter_result)\
	 );\
__asm__ __volatile__(\
        "4:ret\n\t"\
        "2:\n"\
"/ reset __except_list to previous exception function\n\t"\
				"movl %0,%%fs:__except_list\n" : : "r" (__vcer.prev) : "memory");\
--__vcer.trylevel;\
__asm__ __volatile__("/END_EXCEPT\n");\
if(__xcpt_happened && (## args))

#undef _finally
#define _finally \
__asm__ __volatile__(\
"\n/ BEGIN_FINALLY\n"\
".section .rdata\n"\
".align 16, 0x0\n\t"\
	"5:.int -1, 0, 1f\n"\
".section .text\n\t"\
"/ reset __except_list to previous exception function\n\t"\
	"movl __Previous_Except_Reg(%ebp),%eax\n\t"\
	"movl %eax,%fs:__except_list\n"\
	"call 1f\n\t"\
	"jmp  2f\n"\
        "1:\n"\
	"/ END_FINALLY\n");\
        if(1)

#undef _END_FINALLY
#define _END_FINALLY \
__asm__ __volatile__(\
"ret\n"\
"2:\n\t");\
--__vcer.trylevel;

#define RpcEndFinally	_END_FINALLY }

//#define _try try
#define __try _try
#define __try__ _try
//#define _except except
#define __except _except
#define __except__ _except
//#define _finally finally
#define __finally _finally
#define __finally__ _finally

#ifdef __cplusplus
}
#endif

#pragma pack(pop)

#endif /* _EXCPT_H_ */

#endif /* RC_INVOKED */

//#endif /* __STRICT_ANSI__ */

