#include <windows.h>
#include "excpt2.h"
#define TRYLEVEL_NONE -1

#ifdef __cplusplus
extern "C" {
#endif
	void _global_unwind2(void*);
	void _local_unwind2(void*,int);
#ifdef __cplusplus
};
#endif

int __cdecl mexcept_handler3(
	struct _EXCEPTION_RECORD*	pExceptionRecord,
	VC_EXCEPTION_REGISTRATION*	pRegistrationFrame,
	struct _CONTEXT*		pContextRecord,
	void*
	)
{
	VC_EXCEPTION_REGISTRATION*	__vcer=(VC_EXCEPTION_REGISTRATION*)((long*)pRegistrationFrame-2);
	long	filterFuncRet;
	long trylevel;
	EXCEPTION_POINTERS exceptPtrs;
	SCOPETABLE* pScopeTable;


	__asm__ __volatile__("cld"); // Clear the direction flag (make no assumptions!)

	// if neither the EXCEPTION_UNWINDING nor EXCEPTION_EXIT_UNWIND bit
	// is set... This is true the first time through the handler (the
	// non-unwinding case)
	if ( ! (pExceptionRecord->ExceptionFlags
		 & (EH_UNWINDING | EH_EXIT_UNWIND)
               ) )
	{
		// Build the EXCEPTION_POINTERS structure on the stack
		exceptPtrs.ExceptionRecord = pExceptionRecord;
		exceptPtrs.ContextRecord = pContextRecord;

		// Put the pointer to the EXCEPTION_POINTERS 4 bytes below the
		// establisher frame. See ASM code for GetExceptionInformation
		__vcer->xcept_ptrs = (unsigned long)&exceptPtrs;

		// Get initial "trylevel" value
		trylevel = __vcer->trylevel ;

		// Get a pointer to the scopetable array
		pScopeTable = __vcer->tbl_ptr;

search_for_handler: 
		if ( trylevel != TRYLEVEL_NONE )
		{
			if ( pScopeTable[trylevel].lpfnFilter )
			{


			// !!!Very Important!!! Switch to original EBP. This is
			// what allows all locals in the frame to have the same
			// value as before the exception occurred.


				// Call the filter function
				__asm__ __volatile__("pushl %%ebp\n\t"\
						"movl %2,%%ebp\n\t"\
						"call *%1\n\t"\
						"popl %%ebp\n\t": "=a" (filterFuncRet): "r" (pScopeTable[trylevel].lpfnFilter), "m" (__vcer->_ebp) );

				if ( filterFuncRet != EXCEPTION_CONTINUE_SEARCH )
				{
					if ( filterFuncRet < 0 ) // EXCEPTION_CONTINUE_EXECUTION
						return ExceptionContinueExecution;

					// If we get here, EXCEPTION_EXECUTE_HANDLER was specified

					// Does the actual OS cleanup of registration frames
					// Causes this function to recurse
					_global_unwind2( pRegistrationFrame );


					// Once we get here, everything is all cleaned up, except
					// for the last frame, where we'll continue execution
//				PUSH EBP // Save EBP
//				EBP = pRegistrationFrame->_ebp // Set EBP for __local_unwind2
//why change EBP???

					_local_unwind2( pRegistrationFrame, trylevel );

// 				POP EBP

					// Set the current trylevel to whatever SCOPETABLE entry
					// was being used when a handler was found
					// why?
					__vcer->trylevel = pScopeTable->previousTryLevel;

					// Call the _except {} block. Never returns.
//					__vcer->tbl_ptr[trylevel].lpfnHandler();

					__asm__ __volatile__("movl %0, %%esp\n\t"\
							"movl %1, %%ebp\n\t"\
							"call *%2": : "r" (__vcer->stan_stack), "r" (__vcer->_ebp), "r" (pScopeTable->lpfnHandler));

				}//continue search
			}//no filter

			__vcer=(VC_EXCEPTION_REGISTRATION*)(((long*)__vcer->prev)-2);
			trylevel = pScopeTable->previousTryLevel;
			pScopeTable = __vcer->tbl_ptr;

			goto search_for_handler;
		}
		else // trylevel == TRYLEVEL_NONE
		{
			//retvalue == DISPOSITION_CONTINUE_SEARCH;
			return ExceptionContinueSearch;
		}
	}
	else // EXCEPTION_UNWINDING or EXCEPTION_EXIT_UNWIND flags are set
	{
//		PUSH EBP // Save EBP
//		EBP = pRegistrationFrame->_ebp // Set EBP for __local_unwind2
//why ???
//		__asm__ __volatile__("pushl %%ebp\n\tmovl %0,%%ebp": :"m" (__vcer->_ebp));

		_local_unwind2( pRegistrationFrame, TRYLEVEL_NONE );

//		__asm__ __volatile__("pop %ebp"); // Restore EBP

//		retvalue == DISPOSITION_CONTINUE_SEARCH;
		return ExceptionContinueSearch;
	}
}

